Unit GSP2R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, GSU1R_p, UTGS10_p;

procedure GSP2R(RLAM :Real; var ISEED :Integer; N :Integer;
                var K :Array of Integer; var IERR :Integer);

implementation

procedure GSP2R(RLAM :Real; var ISEED :Integer; N :Integer;
                var K :Array of Integer; var IERR :Integer);
var
I,NMIN,NMAX :Integer;
PS,PN,X :Real;
PP :Array [0..84] of Real;
R :Array [0..0] of Real;
const
SYS087 :Real = 1.0E-5;
RLAM1 :Real = -1.0;
NN :Integer = 0;
J :Integer = 0;
P :Real = 0.0;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14;
begin
R[0] := 0.0;
IERR := 0;
if ( RLAM >= 0. ) and ( RLAM <= 40.0 ) 
 then goto _1;
IERR := 65;
goto _13;
_1:
if ( RLAM = RLAM1 ) 
 then goto _3;
for I:=1 to 85 do
 begin
  PP[I-1] := 0.0;
_2:
 end;
NMIN := 1;
J := 1;
P := Exp(-RLAM);
PP[0] := P;
RLAM1 := RLAM;
_3:
for I:=1 to N do
 begin
  PS := PP[J-1];
  K[I-1] := 0;
  GSU1R(ISEED,1,R);
  if ( R[0] > PS ) 
   then goto _7;
  NMIN := 1;
  NMAX := J+1;
_4:
  NN := (NMAX+NMIN-1) div 2;
  if ( NMAX-NMIN <= 1 ) 
   then goto _6;
  if ( R[0] <= PP[NN-1] ) 
   then goto _5;
  NMIN := NN+1;
  goto _4;
_5:
  NMAX := NN+1;
  goto _4;
_6:
  if ( NMIN = 85 ) 
   then goto _7;
  K[I-1] := NMIN-1;
  goto _12;
_7:
  PN := P;
  NN := J+1;
  X := J-1;
_8:
  X := X+1.0;
  if ( R[0] <= PS ) 
   then goto _11;
  PN := PN*RLAM/X;
  PS := PS+PN;
  if ( PN <= SYS087*PS ) 
   then goto _10;
  if ( NN > 85 ) 
   then goto _9;
  PP[NN-1] := PS;
  P := PN;
  J := NN;
_9:
  NN := NN+1;
  goto _8;
_10:
  GSU1R(ISEED,1,R);
  K[I-1] := Trunc( (0.5+R[0])*RLAM+NN );
  goto _12;
_11:
  K[I-1] := NN-1;
_12:
 end;
goto _14;
_13:
UTGS10(IERR,2);
_14:
end;

end.
